---
title: MediaStreamTrack.applyConstraints()
slug: Web/API/MediaStreamTrack/applyConstraints
tags:
  - API
  - Constraints
  - Media Capture and Streams API
  - Media Streams API
  - MediaStreamTrack
  - Method
  - applyConstraints
---
<div>{{APIRef("Media Capture and Streams")}}</div>

<p><span class="seoSummary">The <code><strong>applyConstraints</strong></code><strong><code>()</code></strong> method of the {{domxref("MediaStreamTrack")}} interface applies a set of constraints to the track; these constraints let the Web site or app establish ideal values and acceptable ranges of values for the constrainable properties of the track, such as frame rate, dimensions, echo cancelation, and so forth.</span></p>

<p>Constraints can be used to ensure that the media meets certain guidelines you prefer. For example, you may prefer high-density video but require that the frame rate be a little low to help keep the data rate low enough not overtax the network. Constraints can also specify ideal and/or acceptable sizes or ranges of sizes. See <a href="/en-US/docs/Web/API/Media_Streams_API/Constraints#Applying_constraints">Applying constraints</a> in <a href="/en-US/docs/Web/API/Media_Streams_API/Constraints">Capabilities, constraints, and settings</a> for more information on how to apply your preferred constraints.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">const <em>appliedPromise</em> = <em>track</em>.applyConstraints([<em>constraints</em>])</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>constraints</code> {{optional_inline}}</dt>
 <dd>A {{domxref("MediaTrackConstraints")}} object listing the constraints to apply to the track's constrainable properties; any existing constraints are replaced with the new values specified, and any constrainable properties not included are restored to their default constraints. If this parameter is omitted, all currently set custom constraints are cleared. This object represents the basic set of constraints that must apply for the {{jsxref("Promise")}} to resolve. The object may contain an advanced property containing an array of additional <code>MediaTrackConstraints</code> objects, which are treated as exact requires. </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref("Promise")}} which resolves when the constraints have been successfully applied. If the constraints cannot be applied, the promise is rejected with a {{domxref("MediaStreamError")}} whose name is <code>OverconstrainedError</code>, to indicate that the constraints could not be met. This can happen if the specified constraints are too strict to find a match when attempting to configure the track.</p>

<h2 id="Examples">Examples</h2>

<p>The following shows how to specify a basic and advanced set of constraints. It specifies that the page or web app needs a width between 640 and 1280 and a height between 480 and 720, with the later number in each pair being preferred. The advanced property further specifies that an image size of 1920 by 1280 is the preferred or an aspect ratio of 1.333 if that is not available. Note that these constraints also illustrate what the spec refers to as a <em>backoff strategy</em>.</p>

<pre class="brush: js notranslate">const constraints = {
  width: {min: 640, ideal: 1280},
  height: {min: 480, ideal: 720},
  advanced: [
    {width: 1920, height: 1280},
    {aspectRatio: 1.333}
  ]
};

navigator.mediaDevices.getUserMedia({ video: true })
.then(mediaStream =&gt; {
  const track = mediaStream.getVideoTracks()[0];
  track.applyConstraints(constraints)
  .then(() =&gt; {
    // Do something with the track such as using the Image Capture API.
  })
  .catch(e =&gt; {
    // The constraints could not be satisfied by the available devices.
  });
});
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Media Capture', '#dom-mediatrackconstraints', 'applyConstraints()')}}</td>
   <td>{{Spec2('Media Capture')}}</td>
   <td>Initial definition.</td>
  </tr>
  <tr>
   <td>{{SpecName('MediaStream Image', '#mediatrackconstraintset-section','applyConstraints()')}}</td>
   <td>{{Spec2('MediaStream Image')}}</td>
   <td>Adds image constraints.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.MediaStreamTrack.applyConstraints")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/MediaStream_Image_Capture_API">MediaStream Image Capture API</a></li>
</ul>
